import string
import _log2vis


def log2vis(text, output_length=80, before=' ', after='\n'):
    """ Convert logical to visual, handling line breaks as well. """
    
    outtext = ""
    
    for log_line in string.split(text, '\n'):
        if len(log_line) and log_line[-1] == '\r': log_line = log_line[:-1]
        vis_line = _log2vis.log2vis(log_line)

        while len(vis_line) > output_length: # we need to divide
            # find first space after length
            fragment = string.split(vis_line[-output_length:], ' ', 1)
            try:
                fragment = fragment[1]
            except:
                fragment = ""
            outtext = outtext + (before * (output_length - len(fragment) - 1) ) + fragment + after
            vis_line = vis_line[:-len(fragment)]
         
        outtext = outtext + (before * (output_length - len(vis_line) - 1)) + vis_line + after 
    
    return outtext
